<script lang="ts">
  import { onMount } from "svelte";
  import { type EventSettings, GetEventSettings, GetEnvironmentTopology } from '@models/EventSettings';
  import type { PageData } from './$types';
  import Topology from "@components/Topology/Topology.svelte";
  import { eventId } from '@stores';
  import { TeamById } from "@models/Team";

  export let data: PageData;
  $: teamId = data.teamId;
  let eventSettings = GetEventSettings($eventId);
  let teamNum: number | undefined = undefined;

  onMount(async () => {
    if (teamId) {
      teamNum = (await TeamById(teamId)).competition_id;
    }
  });
</script>

<svelte:head>
  <title>Topology</title>
</svelte:head>

<div class="container-fluid">
  {#await eventSettings}
    <p>Loading...</p>
  {:then ev}
    {#if GetEnvironmentTopology(ev)}
      <div class="d-flex min-vh-100 p-4">
        <Topology
          team={{id: teamId, competition_id: teamNum}}
          autoResize
          staticCanvas
          nodes={GetEnvironmentTopology(ev)}
        />
      </div>
    {:else}
      <p>No topology is configured for this event</p>
    {/if}
  {:catch e}
    <h1>Event not found!</h1>
    <p>We couldn't find your selected event; please select one from the NavBar!</p>
  {/await}
</div>
